/*
 * $Id: Parser.java,v 1.7 2006/02/15 16:23:59 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.koike.core.parser;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * N-gramp[U[
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.7 $
 */
public class Parser {
	private int ngramLength;

	/**
	 * RXgN^
	 * @param ngram N-gram
	 */
	public Parser(int ngram) {
		ngramLength = ngram;
	}
	/**
	 * w肳ꂽN-gram
	 * @param doc ̕
	 * @return n-gramꂽ
	 * @throws ParserException Ɏs
	 */
	public Term[] parse(String doc) throws ParserException {
		HashMap<String, Term> map = new HashMap<String, Term>();

		int loopCnt = doc.length() - (ngramLength-1);
		if(loopCnt <= 0) {
			throw new ParserException( "^ꂽ̒ɑ΂N-gram傫܂" );
		}

		// w肳ꂽŕ
		for(int cnt = 0; cnt < loopCnt; cnt++) {
			int tokenLength = ngramLength - ((cnt-loopCnt) <= 0 ? 0 : cnt-loopCnt);
			String token = doc.substring(cnt, cnt + tokenLength);

			Term key = (Term)map.get(token);
			if(key == null) {
				key = new Term(token);
			}
			// ǉ
			key.add(cnt);
			map.put(token, key);

			Thread.yield();
		}

		// nbV}bv̓ezɕϊĕԂ
		ArrayList<Term> list = new ArrayList<Term>();
		for(Term term : map.values()) {
			list.add(term);
		}

		return list.toArray(new Term[0]);
	}
	/**
	 * n-gramŕ
	 * @param doc ̕
	 * @return w蕶ŕꂽf
	 * @throws ParserException Ɏs
	 */
	public String[] split(String doc) throws ParserException {
		int loopCnt = doc.length() - (ngramLength-1);
		if(loopCnt <= 0) {
			throw new ParserException( "^ꂽ̒ɑ΂N-gram傫܂" );
		}

		String[] tokens = new String[loopCnt];

		// w肳ꂽŕ
		for(int cnt = 0; cnt < loopCnt; cnt++) {
			int tokenLength = ngramLength - ((cnt-loopCnt) <= 0 ? 0 : cnt-loopCnt);
			tokens[cnt] = doc.substring(cnt, cnt + tokenLength);
		}

		return tokens;
	}
}
